unit Advanced;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Main, StdCtrls, ExtCtrls;

type
  TfrmAdvanced = class(TForm)
    btnOK: TButton;
    GroupBox4: TGroupBox;
    chkBTB_EN: TCheckBox;
    chkRSTK_EN: TCheckBox;
    chkLOOP_EN: TCheckBox;
    chkLSSER: TCheckBox;
    GroupBox1: TGroupBox;
    chkDTE_EN: TCheckBox;
    chkMEM_BYP: TCheckBox;
    radIORT: TRadioGroup;
    GroupBox2: TGroupBox;
    chkHLF_CLK: TCheckBox;
    radCLK: TRadioGroup;
    chkFAST_FPU: TCheckBox;
    procedure btnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowRegisters;
  end;

var
  frmAdvanced: TfrmAdvanced;

implementation

{$R *.DFM}

procedure TfrmAdvanced.ShowRegisters;
begin
  if (CCR4_value and $8 = 0) then
    chkMEM_BYP.state := cbUnchecked
  else
    chkMEM_BYP.state := cbChecked;
  if (CCR4_value and $10 = 0) then
    chkDTE_EN.state := cbUnchecked
  else
    chkDTE_EN.state := cbChecked;
  if (CCR4_value and $20 = 0) then
    chkFAST_FPU.state := cbUnchecked
  else
    chkFAST_FPU.state := cbChecked;
  radIORT.ItemIndex := CCR4_value and $7;

  if (PCR0_value and $1 = 0) then
    chkRSTK_EN.state := cbUnchecked
  else
    chkRSTK_EN.state := cbChecked;
  if (PCR0_value and $2 = 0) then
    chkBTB_EN.state := cbUnchecked
  else
    chkBTB_EN.state := cbChecked;
  if (PCR0_value and $4 = 0) then
    chkLOOP_EN.state := cbUnchecked
  else
    chkLOOP_EN.state := cbChecked;
  if (PCR0_value and $80 = 0) then
    chkLSSER.state := cbUnchecked
  else
    chkLSSER.state := cbChecked;

  if (PMR_value and $4 = 0) then
    chkHLF_CLK.state := cbUnchecked
  else
    chkHLF_CLK.state := cbChecked;
  radCLK.ItemIndex := PMR_value and $3
end;

procedure TfrmAdvanced.btnOKClick(Sender: TObject);
begin
  Self.Close
end;

procedure TfrmAdvanced.FormCreate(Sender: TObject);
begin
  if (Screen.Width > Width) and (Screen.Height > Height) then
    Self.SetBounds((Screen.Width - Width) shr 1, (Screen.Height - Height) shr 1,
     Width, Height)
  else
    Self.SetBoundS(0, 0, Width, Height);
  ShowRegisters
end;

end.
